1#!/bin/sh
2# SPDX-License-Identifier: GPL-2.0
3#
4# Tests whether a suitable Rust toolchain is available.
5
6set -e
7
8min_tool_version=$(dirname $0)/min-tool-version.sh
9
10# Convert the version string x.y.z to a canonical up-to-7-digits form.
11#
12# Note that this function uses one more digit (compared to other
13# instances in other version scripts) to give a bit more space to
14# `rustc` since it will reach 1.100.0 in late 2026.
15get_canonical_version()
16{
17	IFS=.
18	set -- $1
19	echo $((100000 * $1 + 100 * $2 + $3))
20}
21
22# Print a reference to the Quick Start guide in the documentation.
23print_docs_reference()
24{
25	echo >&2 "***"
26	echo >&2 "*** Please see Documentation/rust/quick-start.rst for details"
27	echo >&2 "*** on how to set up the Rust support."
28	echo >&2 "***"
29}
30
31# Print an explanation about the fact that the script is meant to be called from Kbuild.
32print_kbuild_explanation()
33{
34	echo >&2 "***"
35	echo >&2 "*** This script is intended to be called from Kbuild."
36	echo >&2 "*** Please use the 'rustavailable' target to call it instead."
37	echo >&2 "*** Otherwise, the results may not be meaningful."
38	exit 1
39}
40
41# If the script fails for any reason, or if there was any warning, then
42# print a reference to the documentation on exit.
43warning=0
44trap 'if [ $? -ne 0 ] || [ $warning -ne 0 ]; then print_docs_reference; fi' EXIT
45
46# Check that the expected environment variables are set.
47if [ -z "${RUSTC+x}" ]; then
48	echo >&2 "***"
49	echo >&2 "*** Environment variable 'RUSTC' is not set."
50	print_kbuild_explanation
51fi
52
53if [ -z "${BINDGEN+x}" ]; then
54	echo >&2 "***"
55	echo >&2 "*** Environment variable 'BINDGEN' is not set."
56	print_kbuild_explanation
57fi
58
59if [ -z "${CC+x}" ]; then
60	echo >&2 "***"
61	echo >&2 "*** Environment variable 'CC' is not set."
62	print_kbuild_explanation
63fi
64
65# Check that the Rust compiler exists.
66if ! command -v "$RUSTC" >/dev/null; then
67	echo >&2 "***"
68	echo >&2 "*** Rust compiler '$RUSTC' could not be found."
69	echo >&2 "***"
70	exit 1
71fi
72
73# Check that the Rust bindings generator exists.
74if ! command -v "$BINDGEN" >/dev/null; then
75	echo >&2 "***"
76	echo >&2 "*** Rust bindings generator '$BINDGEN' could not be found."
77	echo >&2 "***"
78	exit 1
79fi
80
81# Check that the Rust compiler version is suitable.
82#
83# Non-stable and distributions' versions may have a version suffix, e.g. `-dev`.
84rust_compiler_output=$( \
85	LC_ALL=C "$RUSTC" --version 2>/dev/null
86) || rust_compiler_code=$?
87if [ -n "$rust_compiler_code" ]; then
88	echo >&2 "***"
89	echo >&2 "*** Running '$RUSTC' to check the Rust compiler version failed with"
90	echo >&2 "*** code $rust_compiler_code. See output and docs below for details:"
91	echo >&2 "***"
92	echo >&2 "$rust_compiler_output"
93	echo >&2 "***"
94	exit 1
95fi
96rust_compiler_version=$( \
97	echo "$rust_compiler_output" \
98		| sed -nE '1s:.*rustc ([0-9]+\.[0-9]+\.[0-9]+).*:\1:p'
99)
100if [ -z "$rust_compiler_version" ]; then
101	echo >&2 "***"
102	echo >&2 "*** Running '$RUSTC' to check the Rust compiler version did not return"
103	echo >&2 "*** an expected output. See output and docs below for details:"
104	echo >&2 "***"
105	echo >&2 "$rust_compiler_output"
106	echo >&2 "***"
107	exit 1
108fi
109rust_compiler_min_version=$($min_tool_version rustc)
110rust_compiler_cversion=$(get_canonical_version $rust_compiler_version)
111rust_compiler_min_cversion=$(get_canonical_version $rust_compiler_min_version)
112if [ "$rust_compiler_cversion" -lt "$rust_compiler_min_cversion" ]; then
113	echo >&2 "***"
114	echo >&2 "*** Rust compiler '$RUSTC' is too old."
115	echo >&2 "***   Your version:    $rust_compiler_version"
116	echo >&2 "***   Minimum version: $rust_compiler_min_version"
117	echo >&2 "***"
118	exit 1
119fi
120if [ "$rust_compiler_cversion" -gt "$rust_compiler_min_cversion" ]; then
121	echo >&2 "***"
122	echo >&2 "*** Rust compiler '$RUSTC' is too new. This may or may not work."
123	echo >&2 "***   Your version:     $rust_compiler_version"
124	echo >&2 "***   Expected version: $rust_compiler_min_version"
125	echo >&2 "***"
126	warning=1
127fi
128
129# Check that the Rust bindings generator is suitable.
130#
131# Non-stable and distributions' versions may have a version suffix, e.g. `-dev`.
132#
133# The dummy parameter `workaround-for-0.69.0` is required to support 0.69.0
134# (https://github.com/rust-lang/rust-bindgen/pull/2678). It can be removed when
135# the minimum version is upgraded past that (0.69.1 already fixed the issue).
136rust_bindings_generator_output=$( \
137	LC_ALL=C "$BINDGEN" --version workaround-for-0.69.0 2>/dev/null
138) || rust_bindings_generator_code=$?
139if [ -n "$rust_bindings_generator_code" ]; then
140	echo >&2 "***"
141	echo >&2 "*** Running '$BINDGEN' to check the Rust bindings generator version failed with"
142	echo >&2 "*** code $rust_bindings_generator_code. See output and docs below for details:"
143	echo >&2 "***"
144	echo >&2 "$rust_bindings_generator_output"
145	echo >&2 "***"
146	exit 1
147fi
148rust_bindings_generator_version=$( \
149	echo "$rust_bindings_generator_output" \
150		| sed -nE '1s:.*bindgen ([0-9]+\.[0-9]+\.[0-9]+).*:\1:p'
151)
152if [ -z "$rust_bindings_generator_version" ]; then
153	echo >&2 "***"
154	echo >&2 "*** Running '$BINDGEN' to check the bindings generator version did not return"
155	echo >&2 "*** an expected output. See output and docs below for details:"
156	echo >&2 "***"
157	echo >&2 "$rust_bindings_generator_output"
158	echo >&2 "***"
159	exit 1
160fi
161rust_bindings_generator_min_version=$($min_tool_version bindgen)
162rust_bindings_generator_cversion=$(get_canonical_version $rust_bindings_generator_version)
163rust_bindings_generator_min_cversion=$(get_canonical_version $rust_bindings_generator_min_version)
164if [ "$rust_bindings_generator_cversion" -lt "$rust_bindings_generator_min_cversion" ]; then
165	echo >&2 "***"
166	echo >&2 "*** Rust bindings generator '$BINDGEN' is too old."
167	echo >&2 "***   Your version:    $rust_bindings_generator_version"
168	echo >&2 "***   Minimum version: $rust_bindings_generator_min_version"
169	echo >&2 "***"
170	exit 1
171fi
172if [ "$rust_bindings_generator_cversion" -gt "$rust_bindings_generator_min_cversion" ]; then
173	echo >&2 "***"
174	echo >&2 "*** Rust bindings generator '$BINDGEN' is too new. This may or may not work."
175	echo >&2 "***   Your version:     $rust_bindings_generator_version"
176	echo >&2 "***   Expected version: $rust_bindings_generator_min_version"
177	echo >&2 "***"
178	warning=1
179fi
180
181# Check that the `libclang` used by the Rust bindings generator is suitable.
182#
183# In order to do that, first invoke `bindgen` to get the `libclang` version
184# found by `bindgen`. This step may already fail if, for instance, `libclang`
185# is not found, thus inform the user in such a case.
186bindgen_libclang_output=$( \
187	LC_ALL=C "$BINDGEN" $(dirname $0)/rust_is_available_bindgen_libclang.h 2>&1 >/dev/null
188) || bindgen_libclang_code=$?
189if [ -n "$bindgen_libclang_code" ]; then
190	echo >&2 "***"
191	echo >&2 "*** Running '$BINDGEN' to check the libclang version (used by the Rust"
192	echo >&2 "*** bindings generator) failed with code $bindgen_libclang_code. This may be caused by"
193	echo >&2 "*** a failure to locate libclang. See output and docs below for details:"
194	echo >&2 "***"
195	echo >&2 "$bindgen_libclang_output"
196	echo >&2 "***"
197	exit 1
198fi
199
200# `bindgen` returned successfully, thus use the output to check that the version
201# of the `libclang` found by the Rust bindings generator is suitable.
202#
203# Unlike other version checks, note that this one does not necessarily appear
204# in the first line of the output, thus no `sed` address is provided.
205bindgen_libclang_version=$( \
206	echo "$bindgen_libclang_output" \
207		| sed -nE 's:.*clang version ([0-9]+\.[0-9]+\.[0-9]+).*:\1:p'
208)
209if [ -z "$bindgen_libclang_version" ]; then
210	echo >&2 "***"
211	echo >&2 "*** Running '$BINDGEN' to check the libclang version (used by the Rust"
212	echo >&2 "*** bindings generator) did not return an expected output. See output"
213	echo >&2 "*** and docs below for details:"
214	echo >&2 "***"
215	echo >&2 "$bindgen_libclang_output"
216	echo >&2 "***"
217	exit 1
218fi
219bindgen_libclang_min_version=$($min_tool_version llvm)
220bindgen_libclang_cversion=$(get_canonical_version $bindgen_libclang_version)
221bindgen_libclang_min_cversion=$(get_canonical_version $bindgen_libclang_min_version)
222if [ "$bindgen_libclang_cversion" -lt "$bindgen_libclang_min_cversion" ]; then
223	echo >&2 "***"
224	echo >&2 "*** libclang (used by the Rust bindings generator '$BINDGEN') is too old."
225	echo >&2 "***   Your version:    $bindgen_libclang_version"
226	echo >&2 "***   Minimum version: $bindgen_libclang_min_version"
227	echo >&2 "***"
228	exit 1
229fi
230
231# If the C compiler is Clang, then we can also check whether its version
232# matches the `libclang` version used by the Rust bindings generator.
233#
234# In the future, we might be able to perform a full version check, see
235# https://github.com/rust-lang/rust-bindgen/issues/2138.
236cc_name=$($(dirname $0)/cc-version.sh $CC | cut -f1 -d' ')
237if [ "$cc_name" = Clang ]; then
238	clang_version=$( \
239		LC_ALL=C $CC --version 2>/dev/null \
240			| sed -nE '1s:.*version ([0-9]+\.[0-9]+\.[0-9]+).*:\1:p'
241	)
242	if [ "$clang_version" != "$bindgen_libclang_version" ]; then
243		echo >&2 "***"
244		echo >&2 "*** libclang (used by the Rust bindings generator '$BINDGEN')"
245		echo >&2 "*** version does not match Clang's. This may be a problem."
246		echo >&2 "***   libclang version: $bindgen_libclang_version"
247		echo >&2 "***   Clang version:    $clang_version"
248		echo >&2 "***"
249		warning=1
250	fi
251fi
252
253# Check that the source code for the `core` standard library exists.
254#
255# `$KRUSTFLAGS` is passed in case the user added `--sysroot`.
256rustc_sysroot=$("$RUSTC" $KRUSTFLAGS --print sysroot)
257rustc_src=${RUST_LIB_SRC:-"$rustc_sysroot/lib/rustlib/src/rust/library"}
258rustc_src_core="$rustc_src/core/src/lib.rs"
259if [ ! -e "$rustc_src_core" ]; then
260	echo >&2 "***"
261	echo >&2 "*** Source code for the 'core' standard library could not be found"
262	echo >&2 "*** at '$rustc_src_core'."
263	echo >&2 "***"
264	exit 1
265fi
266